#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}

%define mod_conf 73_squirrelmail.conf

%define basedir %{ap_htdocsdir}/squirrelmail
%define varlibdir /var/lib/squirrelmail
%define prefsdir %{varlibdir}/prefs
%define varspooldir /var/spool/squirrelmail
%define attdir %{varspooldir}/attach
%define etcdir /etc/squirrelmail
%define crondir /etc/cron.daily

Summary: Squirrelmail is a webmail client for PHP4.
Name: squirrelmail
Version: 1.4.1
Release: 2mdk
License: GPL
URL: http://www.squirrelmail.org/
Group: System/Servers
Source0: %{name}-%{version}.tar.bz2
Source2: squirrelmail-RPM.readme
Source3: http://www.squirrelmail.org/plugins/address_add.1.9-1.2.8.tar.gz
Source4: http://www.squirrelmail.org/plugins/block_sender.2.02-1.4.0.tar.bz2
Source5: http://www.squirrelmail.org/plugins/login_image-0.2.tar.bz2
Source6: http://www.squirrelmail.org/plugins/secure_login-1.2-1.2.8.tar.bz2
Source7: http://www.squirrelmail.org/plugins/compatibility-1.2.tar.bz2
Source8: http://www.squirrelmail.org/plugins/change_pass-2.2-1.4.x.tar.bz2
Patch1:  squirrelmail-1.4.1-config.php.patch.bz2
Patch5:  login_image-position.patch.bz2
Patch6:  secure_login-stayinssl.patch.bz2
Patch7:  squirrelmail-1.4.1-default_folder_prefix.patch.bz2
Patch8:  squirrelmail-1.4.1-select_range.patch.bz2
Patch9:	 squirrelmail-1.4.1-thread.patch.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Requires: apache >= 1.3.19
Requires: mod_php >= 4.0.4
Requires: php-imap
Requires: perl 
Requires: tmpwatch >= 2.8
Requires: MailTransportAgent
Requires: aspell
Requires: poppassd-ceti
BuildRequires: ADVX-build >= 1.2
Provides: ADVXpackage
# Previous versions of apache2-mod_php do not provide mod_php
Conflicts: apache2-mod_php <= 2.0.44_4.3.1-1mdk

%description
SquirrelMail is a standards-based webmail package written in PHP4. It
includes built-in pure PHP support for the IMAP and SMTP protocols, and
all pages render in pure HTML 4.0 (with no Javascript) for maximum
compatibility across browsers.  It has very few requirements and is very
easy to configure and install. SquirrelMail has all the functionality
you would want from an email client, including strong MIME support,
address books, and folder manipulation.

%package poutils
Summary: Some development tools for SquirrelMail.
Group: System/Servers
Requires: %{name} = %{version}

%description poutils
This package includes some development tools for squirrelmail
i18n, including the main po file and some compilation scripts.

%prep
%setup -q
%patch7 -p1
%patch8 -p1
%patch9 -p1
rm -f plugins/make_archive.pl

if [ -d plugins/address_add ]; then
echo "address_add plugin already present"
else
pushd plugins
gzip -dc %{SOURCE3} | tar -xvf -
#Do not use chmod -R 644, otherwise you can't chdir to the
#directory anymore
chmod 644 address_add/*.php
chmod 644 address_add/classes/*.php
popd
fi

if [ -d plugins/block_sender ]; then
echo "block_sender plugin already present"
else
pushd plugins
tar -xjvf %{SOURCE4}
chmod 755 block_sender
#cp block_sender/block_sender.php.flat block_sender/block_sender.php
#cp block_sender/options.php.flat block_sender/options.php
perl -pi -e 's|data_dir \. \$username|data_dir ."/". \$username|;' \
	block_sender/*.php
popd
fi

if [ -d plugins/login_image ]; then
echo "login_image plugin already present"
else
pushd plugins; tar -xjvf %{SOURCE5}; chmod 0644 login_image/*.php; popd
fi
%patch5 -p0

if [ -d plugins/secure_login ]; then
echo "secure_login plugin already present"
else
pushd plugins; tar -xjvf %{SOURCE6}; popd
fi
pushd plugins/secure_login; cp -f config.php.sample config.php; popd
%patch6 -p0

if [ -d plugins/compatibility ]; then
echo "compatibility plugin already present"
else
pushd plugins; tar -xjvf %{SOURCE7}; popd
fi

if [ -d plugins/change_pass ]; then
echo "change_pass plugin already present"
else
pushd plugins; tar -xjvf %{SOURCE8}; popd
rm -rf change_pass/courierpassd-*
fi

# Rearrange the documentation
mv AUTHORS ChangeLog COPYING INSTALL README UPGRADE doc/
mv ReleaseNotes doc/ReleaseNotes.txt
mv themes/README.themes doc/
for f in `find plugins -name "README*" -or -name INSTALL \
		   -or -name CHANGES -or -name HISTORY`; do
    mkdir -p doc/`dirname $f`
    mv $f $_
done
mv doc/plugins/squirrelspell/doc/README doc/plugins/squirrelspell
rmdir doc/plugins/squirrelspell/doc
mv plugins/squirrelspell/doc/* doc/plugins/squirrelspell
rm -f doc/plugins/squirrelspell/index.php
rmdir plugins/squirrelspell/doc
mv doc/index.html doc/index2.html

cat << EOF > doc/index.html
Your squirrelmail package is installed in <a href=/squirrelmail/>%{ap_htdocsdir}/squirrelmail</a>, and is aliased to <a href=/webmail>/webmail</a>.
<p>
<a href=index2.html>Read documentation</a>
EOF

# Fixup various files
echo "left_refresh=300" >> data/default_pref
%patch1 -p0
for f in contrib/RPM/squirrelmail.cron contrib/RPM/config.php.redhat; do
    perl -pi -e "s|__ATTDIR__|%{attdir}|g;"\
             -e "s|__PREFSDIR__|%{prefsdir}|g;" $f
done

cp %{SOURCE2} doc/RPM.readme

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
mkdir -p -m0755 %{buildroot}%{etcdir}
mkdir -p -m0755 %{buildroot}%{prefsdir}
mkdir -p -m0755 %{buildroot}%{attdir}
mkdir -p -m0755 %{buildroot}%{basedir}
mkdir -p -m0755 %{buildroot}%{crondir}

# install default_pref
install -m 0644 data/default_pref %{buildroot}%{prefsdir}

# install the config files
mkdir -p -m0755 %{buildroot}%{basedir}/config
install -m 0644 config/*.php %{buildroot}%{basedir}/config/
install -m 0644 contrib/RPM/config.php.redhat %{buildroot}%{etcdir}/config.php
# symlink
ln -s %{etcdir}/config.php %{buildroot}%{basedir}/config/config.php
install -m 0755 config/*.pl %{buildroot}%{basedir}/config/

# install index.php
install -m 0644 index.php %{buildroot}%{basedir}/

# install classes
pwd
mkdir -p -m0755 %{buildroot}%{basedir}/class
cp -pr class %{buildroot}%{basedir}

# install include
mkdir -p -m0755 %{buildroot}%{basedir}/include
cp -pr include %{buildroot}%{basedir}

# install functions
mkdir -p -m0755 %{buildroot}%{basedir}/functions
install -m 0644 functions/* %{buildroot}%{basedir}/functions/

# install src
mkdir -p -m0755 %{buildroot}%{basedir}/src
install -m 0644 src/* %{buildroot}%{basedir}/src/

# install themes
mkdir -p -m0755 %{buildroot}%{basedir}/themes
install -m 0644 themes/*.php %{buildroot}%{basedir}/themes/
mkdir -p -m0755 %{buildroot}%{basedir}/themes/css
install -m 0644 themes/css/*.css %{buildroot}%{basedir}/themes/css/

# install images
mkdir -p -m0755 %{buildroot}%{basedir}/images
install -m 0644 images/* %{buildroot}%{basedir}/images/

# install the plugins
cp -rp plugins %{buildroot}%{basedir}

# install the locales.
cp -rp locale %{buildroot}%{basedir}

# install help files
cp -rp help %{buildroot}%{basedir}

# po will go into the poutils package, so just copy it
cp -rp po %{buildroot}%{basedir}

# install the cron script
install -m 0755 contrib/RPM/squirrelmail.cron %{buildroot}/%{crondir}

cat <<EOF > %{mod_conf}
<IfModule mod_alias.c>
Alias /webmail %{basedir}
</IfModule>
<Directory %{basedir}>
    <IfModule mod_php4.c>
	php_admin_value session.bug_compat_42 Off
# Otherwise can't send mails
	php_admin_value safe_mode Off
    </IfModule>
</Directory>
EOF
bzip2 %{mod_conf}
%ADVXinstconf ./%{mod_conf}.bz2 %{mod_conf}

%ADVXinstdoc %{name}-%{version}

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%pre 
%_pre_useradd apache %{ap_datadir} /bin/sh
#Check config file sanity
%AP13pre

%post
# The FIXME alias is because rpmlint says it's dangerous to use perl 
# in post scripts. We know that, but there is no safer solution.
alias FIXME="perl -pi -e"
#Upgrade: remove line and reinstall it (only for Apache 1.3)
if [ $1 -gt 1 ]; then
   for config in %{ap_base}/conf/{httpd,httpd-perl}.conf; do
     if [ -e $config ]; then
	FIXME 's/.*//s if (/Include.*squirrelmail.conf$/i);' $config
	echo "Include conf.d/%{mod_conf}" >> $config
     fi
   done
fi
#Install
if [ $1 = "1" ]; then
   for config in %{ap_base}/conf/{httpd,httpd-perl}.conf; do
     if [ -e $config ]; then
	echo "Include conf.d/%{mod_conf}" >> $config
     fi
   done
fi
# Put correct hostname in config. We do this every time, since we change the
# .rpmnew as well. This is safe even if someone already modified the config,
# because the script will not find __HOSTNAME__ in the file and will do
# nothing.
for f in %{etcdir}/config.php %{etcdir}/config.php.rpmnew; do
    FIXME "s|__HOSTNAME__|$HOSTNAME|g" $f 2>/dev/null
done
%ADVXpost

%postun
alias FIXME="perl -pi -e"
#Uninstall (only for Apache 1.3)
if [ $1 = "0" ]; then
   for config in %{ap_base}/conf/{httpd,httpd-perl}.conf; do
     if [ -e $config ]; then
	FIXME 's/.*//s if (/Include.*squirrelmail.conf$/i);' $config
     fi
   done
fi
%ADVXpost


%files
%defattr(-,root,root)
%config(noreplace) %{ap_confd}/%{mod_conf}
%config %dir %{etcdir}
%config(noreplace) %{etcdir}/config.php
%doc doc/*
%dir %{basedir}
%dir %{varlibdir}
%dir %{varspooldir}
%{basedir}/class
%{basedir}/config
%{basedir}/functions
%{basedir}/help
%{basedir}/images
%{basedir}/include
%{basedir}/locale
%{basedir}/plugins
%{basedir}/src
%{basedir}/themes
%{basedir}/index.php
%attr(0770, root, apache) %dir %{prefsdir}
%attr(0730, root, apache) %dir %{attdir}
%{prefsdir}/default_pref
%{crondir}/squirrelmail.cron
%{ap_webdoc}/*

%files poutils
%defattr(-,root,root)
%{basedir}/po

%changelog
* Sun Jul 27 2003 Giuseppe Ghib <ghibo@mandrakesoft.com> 1.4.1-2mdk
- Added Patch9 (to avoid Error: "Bad or malformed request.*, Query:
  FETCH..."). Reported by Stefan Van der Eijk.
- Removed Patch0 (unused).

* Sat Jul 26 2003 Giuseppe Ghib <ghibo@mandrakesoft.com> 1.4.1-1mdk
- Release 1.4.1.
- Removed Patch0.
- Added Patch8 from select_range plugin.
- added "session.bug_compat_42 Off" to php config.
- added "safe_mode Off" to php config, otherwise can't send mails.
- change $default_folder_prefix from "mail/" to "", as it's already set
  in this way in the latest uw-imap-2002d rpm.
- Added change_pass plugin to change password (Requires: poppassd-ceti).

* Thu Mar 13 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.2.11-7mdk
- update to address_add.1.9
- do not use trailing slash, but patch the plugins instead

* Wed Mar 12 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.2.11-6mdk
- add requires: aspell
- fix some permissions and added a trailing slash to prefsdir, otherwise
  the block_sender plugin would not work.
- copy block_sender/*.php.flat to *.php, since there are two sets of files,
  one for flat file support (stable) and mysql support (experimental)

* Sat Mar  8 2003 David Walser <luigiwalser@yahoo.com> 1.2.11-5mdk
- Update block_sender and secure_login plugins
- Add compatibility plugin (needed for secure_login)
- Regenerate Patch 6

* Sat Mar  8 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.2.11-4mdk
- backtrack a few changes to maintain compatibility with previous apache
  versions, as David Walser <luigiwalser@yahoo.com> requested.

* Thu Feb 20 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.2.11-3mdk
- fix %{prefdir} permission to (770,root,apache), so it works with php in
  safe_mode (Stefan van der Eijk, this should fix your problem)
- fix requires (no web packages should require php, only mod_php, otherwise
  urpmi might try to install php-cli)
- add %%_pre_useradd apache 
- use ADVX macros
- fix post scripts for both apache versions
- fix the hostname only on install, otherwise, people who masquerade their
  mail as another domain (and thus don't use hostname) 
  will have their webmail broken at upgrade.

* Tue Feb 18 2003 Lenny Cartier <lenny@mandrakesoft.com> 1.2.11-2mdk
- from David Walser <luigiwalser@yahoo.com> :
	- Update address_add plugin

* Sat Feb 15 2003 David Walser <luigiwalser@yahoo.com> 1.2.11-1mdk
- 1.2.11
- Add patch0 to add slash after data_dir (accepted upstream in 1.4.0)
- Update address_add plugin
- Fix permissions on address_add plugin

* Tue Jan 28 2003  Lenny Cartier <lenny@mandrakesoft.com> 1.2.10-4mdk
- remove useless patch ( thx David Walser )

* Mon Jan 27 2003 Lenny Cartier <lenny@mandrakesoft.com> 1.2.10-3mdk
- patch2 from Tzafrir Cohen <tzafrir@technion.ac.il>
        Fix file name wrongly concatinated.

* Mon Jan 13 2003 Stefan van der Eijk <stefan@eijk.nu> 1.2.10-2mdk
- uploaded for David Walser
- Thu Dec 05 2002 David Walser <luigiwalser@yahoo.com> 1.2.10-2mdk
- Update plugins
- Patch 6 for secure_login to stay in SSL mode after login
- Fix prefsdir

* Tue Dec 03 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.2.10-1mdk
- 1.2.10

* Sun Dec 01 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.2.9-1mdk
- 1.2.9

* Mon Sep 16 2002  Lenny Cartier <lenny@mandrakesoft.com> 1.2.8-1mdk
- from David Walser <luigiwalser@yahoo.com> 
	- more merging with Konstantin Riabitsev
	- update address_add and block_sender plugins
	- 1.2.8

* Fri Jun 28 2002 Yves Duret <yduret@mandrakesoft.com> 1.2.7-5mdk
- requires on MailTransportAgent instead of smtpdaemon. i sux.

* Fri Jun 28 2002 Yves Duret <yduret@mandrakesoft.com> 1.2.7-4mdk
- fix requires on smtpdaemon instead /usr/sbin/sendmail (alternatives).

* Wed Jun 26 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.2.7-3mdk
- from David Walser <luigiwalser@yahoo.com> :
	- incorporate some changes from Konstantin Riabitsev
	- replace abook_take with address_add

* Tue Jun 25 2002 David Walser <luigiwalser@yahoo.com> 1.2.7-3mdk
- incorporate some changes from Konstantin Riabitsev
- replace abook_take with address_add

* Tue Jun 25 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.2.7-2mdk
- from David Walser <luigiwalser@yahoo.com> :
        - add plugins: abook_take block_sender login_image secure_login
        - enable plugins: filter delete_move_next abook_take block_sender

* Sun Jun 23 2002 David Walser <luigiwalser@yahoo.com> 1.2.7-1mdk
- fix typo in squirrelmail-RPM.readme
- move more stuff into doc/
- 1.2.7

* Mon May 06 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.2.6-1mdk
- minor changes on Konstantin Riabitsev specfile.

* Thu Jan 24 2002 Konstantin Riabitsev <icon@duke.edu>
- Fix for the horrible remote execution bug in squirrelspell.
  (/me shuts his ears in the door. Bad Dobby!)
- Check whether we need to edit the config.php file before actually
  sed'ing it.
- Release for 1.2.4.

* Wed Jan 23 2002 Konstantin Riabitsev <icon@duke.edu>
- Setting 0755 permissions on the created directories so people
  running the --rebuild with umask 007 don't get a broken install.
- cp'ing the RPM.readme file instead of moving it.
- cp -rp'ing some dirs instead of mv'ing them
- minor bugfixes to %files section.
- organizing docs for the spamcop plugin now as well
- fixes in the default config -- trailing slashes added to the prefsdir
  and attach_dir (squirrelmail's bug, really).

* Mon Jan 21 2002 Konstantin Riabitsev <icon@duke.edu>
- Package for Squirrelmail-1.2.3.
- Accommodation for the themes/css directory.
- Added RPM.readme and a warning message for upgraders
  (I know, I hate myself, too. ;))

* Wed Jan 02 2002 Konstantin Riabitsev <icon@duke.edu>
- Updated paths as per the list discussion. If you are upgrading, please
  move the existing preferences from /var/squirrelmail/prefs to
  /var/lib/squirrelmail/prefs
- A cleanup cron script. Runs daily and cleans up any old temp attachments
  files in the attachment dir (10 days or older).

* Tue Jan 01 2002 Konstantin Riabitsev <icon@duke.edu>
- Package for the 1.2.2 release.

* Fri Dec 28 2001 Konstantin Riabitsev <icon@duke.edu>
- Changed Requires: sendmail to Requires: /usr/sbin/sendmail so people
  with Postfix can install it as well.
- Changed the chowning of the /var/squirrelmail/* to doing it the right
  way, with %attr's.

* Tue Dec 25 2001 Konstantin Riabitsev <icon@duke.edu>
- First spec file build for RH7.
- Locale patches.
- Fixed russian po/mo files (still screws up on occasion! php/gettext is
  so broken!).
- Default config for RH7 systems.
